=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.2.3

=end

require 'cgi'

module Pulp2to3MigrationClient
  class Pulp2RepositoriesApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # List pulp2 repositorys
    # ViewSet for Pulp2Repositories model.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :is_migrated is_migrated
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :not_in_plan not_in_plan
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :pulp2_repo_id pulp2_repo_id
    # @option opts [String] :pulp2_repo_id__in pulp2_repo_id__in
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Paginatedpulp2to3MigrationPulp2RepositoryResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List pulp2 repositorys
    # ViewSet for Pulp2Repositories model.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :is_migrated is_migrated
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :not_in_plan not_in_plan
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :pulp2_repo_id pulp2_repo_id
    # @option opts [String] :pulp2_repo_id__in pulp2_repo_id__in
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(Paginatedpulp2to3MigrationPulp2RepositoryResponseList, Integer, Hash)>] Paginatedpulp2to3MigrationPulp2RepositoryResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: Pulp2RepositoriesApi.list ...'
      end
      # resource path
      local_var_path = '/pulp/api/v3/pulp2repositories/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'is_migrated'] = opts[:'is_migrated'] if !opts[:'is_migrated'].nil?
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'not_in_plan'] = opts[:'not_in_plan'] if !opts[:'not_in_plan'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = opts[:'ordering'] if !opts[:'ordering'].nil?
      query_params[:'pulp2_repo_id'] = opts[:'pulp2_repo_id'] if !opts[:'pulp2_repo_id'].nil?
      query_params[:'pulp2_repo_id__in'] = opts[:'pulp2_repo_id__in'] if !opts[:'pulp2_repo_id__in'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'Paginatedpulp2to3MigrationPulp2RepositoryResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: Pulp2RepositoriesApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a pulp2 repository
    # ViewSet for Pulp2Repositories model.
    # @param pulp_2to3_migration_pulp2_repository_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Pulp2to3MigrationPulp2RepositoryResponse]
    def read(pulp_2to3_migration_pulp2_repository_href, opts = {})
      data, _status_code, _headers = read_with_http_info(pulp_2to3_migration_pulp2_repository_href, opts)
      data
    end

    # Inspect a pulp2 repository
    # ViewSet for Pulp2Repositories model.
    # @param pulp_2to3_migration_pulp2_repository_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(Pulp2to3MigrationPulp2RepositoryResponse, Integer, Hash)>] Pulp2to3MigrationPulp2RepositoryResponse data, response status code and response headers
    def read_with_http_info(pulp_2to3_migration_pulp2_repository_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: Pulp2RepositoriesApi.read ...'
      end
      # verify the required parameter 'pulp_2to3_migration_pulp2_repository_href' is set
      if @api_client.config.client_side_validation && pulp_2to3_migration_pulp2_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'pulp_2to3_migration_pulp2_repository_href' when calling Pulp2RepositoriesApi.read"
      end
      # resource path
      local_var_path = '{pulp_2to3_migration_pulp2_repository_href}'.sub('{' + 'pulp_2to3_migration_pulp2_repository_href' + '}', CGI.escape(pulp_2to3_migration_pulp2_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'Pulp2to3MigrationPulp2RepositoryResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: Pulp2RepositoriesApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
