=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.2.3

=end

require 'date'

module Pulp2to3MigrationClient
  # A serializer for the Pulp2Repositories
  class Pulp2to3MigrationPulp2RepositoryResponse
    attr_accessor :pulp_href

    # Timestamp of creation.
    attr_accessor :pulp_created

    attr_accessor :pulp2_object_id

    attr_accessor :pulp2_repo_id

    attr_accessor :pulp2_repo_type

    attr_accessor :is_migrated

    attr_accessor :not_in_plan

    # RepositoryVersion to be served
    attr_accessor :pulp3_repository_version

    attr_accessor :pulp3_remote_href

    attr_accessor :pulp3_publication_href

    attr_accessor :pulp3_distribution_hrefs

    attr_accessor :pulp3_repository_href

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'pulp_href' => :'pulp_href',
        :'pulp_created' => :'pulp_created',
        :'pulp2_object_id' => :'pulp2_object_id',
        :'pulp2_repo_id' => :'pulp2_repo_id',
        :'pulp2_repo_type' => :'pulp2_repo_type',
        :'is_migrated' => :'is_migrated',
        :'not_in_plan' => :'not_in_plan',
        :'pulp3_repository_version' => :'pulp3_repository_version',
        :'pulp3_remote_href' => :'pulp3_remote_href',
        :'pulp3_publication_href' => :'pulp3_publication_href',
        :'pulp3_distribution_hrefs' => :'pulp3_distribution_hrefs',
        :'pulp3_repository_href' => :'pulp3_repository_href'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'pulp_href' => :'String',
        :'pulp_created' => :'DateTime',
        :'pulp2_object_id' => :'String',
        :'pulp2_repo_id' => :'String',
        :'pulp2_repo_type' => :'String',
        :'is_migrated' => :'Boolean',
        :'not_in_plan' => :'Boolean',
        :'pulp3_repository_version' => :'String',
        :'pulp3_remote_href' => :'String',
        :'pulp3_publication_href' => :'String',
        :'pulp3_distribution_hrefs' => :'Array<String>',
        :'pulp3_repository_href' => :'String'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
        :'pulp3_repository_version',
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Pulp2to3MigrationClient::Pulp2to3MigrationPulp2RepositoryResponse` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Pulp2to3MigrationClient::Pulp2to3MigrationPulp2RepositoryResponse`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'pulp_href')
        self.pulp_href = attributes[:'pulp_href']
      end

      if attributes.key?(:'pulp_created')
        self.pulp_created = attributes[:'pulp_created']
      end

      if attributes.key?(:'pulp2_object_id')
        self.pulp2_object_id = attributes[:'pulp2_object_id']
      end

      if attributes.key?(:'pulp2_repo_id')
        self.pulp2_repo_id = attributes[:'pulp2_repo_id']
      end

      if attributes.key?(:'pulp2_repo_type')
        self.pulp2_repo_type = attributes[:'pulp2_repo_type']
      end

      if attributes.key?(:'is_migrated')
        self.is_migrated = attributes[:'is_migrated']
      else
        self.is_migrated = false
      end

      if attributes.key?(:'not_in_plan')
        self.not_in_plan = attributes[:'not_in_plan']
      else
        self.not_in_plan = false
      end

      if attributes.key?(:'pulp3_repository_version')
        self.pulp3_repository_version = attributes[:'pulp3_repository_version']
      end

      if attributes.key?(:'pulp3_remote_href')
        self.pulp3_remote_href = attributes[:'pulp3_remote_href']
      end

      if attributes.key?(:'pulp3_publication_href')
        self.pulp3_publication_href = attributes[:'pulp3_publication_href']
      end

      if attributes.key?(:'pulp3_distribution_hrefs')
        if (value = attributes[:'pulp3_distribution_hrefs']).is_a?(Array)
          self.pulp3_distribution_hrefs = value
        end
      end

      if attributes.key?(:'pulp3_repository_href')
        self.pulp3_repository_href = attributes[:'pulp3_repository_href']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @pulp2_object_id.nil?
        invalid_properties.push('invalid value for "pulp2_object_id", pulp2_object_id cannot be nil.')
      end

      if @pulp2_object_id.to_s.length > 255
        invalid_properties.push('invalid value for "pulp2_object_id", the character length must be smaller than or equal to 255.')
      end

      if @pulp2_repo_id.nil?
        invalid_properties.push('invalid value for "pulp2_repo_id", pulp2_repo_id cannot be nil.')
      end

      if @pulp2_repo_type.nil?
        invalid_properties.push('invalid value for "pulp2_repo_type", pulp2_repo_type cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @pulp2_object_id.nil?
      return false if @pulp2_object_id.to_s.length > 255
      return false if @pulp2_repo_id.nil?
      return false if @pulp2_repo_type.nil?
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] pulp2_object_id Value to be assigned
    def pulp2_object_id=(pulp2_object_id)
      if pulp2_object_id.nil?
        fail ArgumentError, 'pulp2_object_id cannot be nil'
      end

      if pulp2_object_id.to_s.length > 255
        fail ArgumentError, 'invalid value for "pulp2_object_id", the character length must be smaller than or equal to 255.'
      end

      @pulp2_object_id = pulp2_object_id
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          pulp_href == o.pulp_href &&
          pulp_created == o.pulp_created &&
          pulp2_object_id == o.pulp2_object_id &&
          pulp2_repo_id == o.pulp2_repo_id &&
          pulp2_repo_type == o.pulp2_repo_type &&
          is_migrated == o.is_migrated &&
          not_in_plan == o.not_in_plan &&
          pulp3_repository_version == o.pulp3_repository_version &&
          pulp3_remote_href == o.pulp3_remote_href &&
          pulp3_publication_href == o.pulp3_publication_href &&
          pulp3_distribution_hrefs == o.pulp3_distribution_hrefs &&
          pulp3_repository_href == o.pulp3_repository_href
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [pulp_href, pulp_created, pulp2_object_id, pulp2_repo_id, pulp2_repo_type, is_migrated, not_in_plan, pulp3_repository_version, pulp3_remote_href, pulp3_publication_href, pulp3_distribution_hrefs, pulp3_repository_href].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        Pulp2to3MigrationClient.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end
        
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
